#
#  Bounded stack language for C/C++
#
BSL type finite-state trans-line

typefaces
r----	C-Plain
i--B-	C-Comment
rb-R-	C-Directive
rb---	C-Keyword
r----	C-Identifier
r----	C-Operator
r----	C-Sequencer
t--Gi	C-String
r--G-	C-Number
t--Ri	C-Escape

state set
T	C-Plain
C	C-Comment
S	C-String
H	C-String

demo string #define hi (char*)" hi\n" + 1 /* hm... */

word range a-zA-Z0-9_

rules
#
#  regular C keywords
#
T	\{C-Keyword}\<asm\>:\<auto\>:\<break\>:\<case\>:\<cdecl\>:\<char\>:\<const\>:\<continue\>:\<default\>:\<do\>:\<double\>:\<else\>:\<enum\>:\<extern\>:\<far\>:\<float\>:\<for\>:\<goto\>:\<if\>:\<int\>:\<long\>:\<offsetof\>:\<register\>:\<return\>:\<sizeof\>:\<signed\>:\<short\>:\<static\>:\<struct\>:\<switch\>:\<typedef\>:\<union\>:\<unsigned\>:\<void\>:\<volatile\>:\<while\>	nop
#
#  C++ keywords
#
T	\{C-Keyword}\<catch\>:\<class\>:\<delete\>:\<friend\>:\<inline\>:\<new\>:\<operator\>:\<private\>:\<protected\>:\<public\>:\<template\>:\<this\>:\<throw\>:\<try\>:\<virtual\>	nop
#
#  Extensions (GNU)
#
T	\{C-Keyword}\<signature\>:\<sigof\>:\<typeof\>	nop
#
#  Other plain C elements
#
T	\{C-Plain}[ \t]+	nop
T	\{C-Identifier}\<[a-zA-Z_][a-zA-Z0-9_]*\>	nop
T	\{C-Directive}##	nop
T	\{C-Directive}#[ \t]*include[ \t]+\{C-Plain}<\{C-String}[^>]*\{C-Plain}>	nop
T	\{C-Directive}#[ \t]*[a-z]*	nop
T	\{C-Number}0[xX][0-9a-fA-F]+:-0[xX][0-9a-fA-F]+:[\-0-9]*.[0-9]+[eE][0-9]+:[\-0-9]+.[0-9]*[eE][0-9]+:[\-0-9]+.[0-9]*:[\-0-9]*.[0-9]+:[0-9]+:-[0-9]+	nop
T	\{C-Comment}/\*	goto C
T	\{C-Comment}//*$	nop
T	"	goto S
T	'	goto H
T	\{C-Operator}<<=:>>=:\+\+:--:<<:>>:<=:>=:==:\!=:>=:\&\&:||:\?:->:\*=:/=:%=:\+=:-=:\&=:|=:\^=:,:=:\:|:\^:>:<:(:):\[:\]:.:-:\+:~:\!:\*:\&:/:%	nop
T	\{C-Sequencer};:\::{:}	nop
#
#  Comments
#
C	[^/*]+	nop
C	\*/	goto T
#
#  Characters (H) and strings (S)
#
SH	[^"'\\]+	nop
S	\{C-Plain}"	goto T
H	\{C-Plain}'	goto T
SH	\{C-Escape}\\[0-9][0-9][0-9]:\\x[0-9A-Fa-f][0-9A-Fa-f]:\\a:\\b:\\e:\\f:\\n:\\r:\\t:\\v:\\0	nop
SH	\{C-Escape}\\\{C-String}?	nop
SH	$	goto T

