#
#  Bounded stack language for HTML
#
BSL type recursive trans-line

typefaces
r----	HTML-Roman
i----	HTML-Italic
rb---	HTML-Bold
t----	HTML-Typewriter
l----	HTML-Large
t--B-	HTML-Comment
t--R-	HTML-Command
r-uB-	HTML-Anchor
t--R-	HTML-Escape
t--G-	HTML-String

state set
R	HTML-Roman
I	HTML-Italic
B	HTML-Bold
T	HTML-Typewriter
L	HTML-Large
A	HTML-Anchor
D	HTML-Command
C	HTML-Comment

demo string <em>Click <a href="here.html">here</a></em>

word range a-zA-Z0-9

rules
#
#  Scan  sequences of non-special characters  first (for speed).
#
RIBTLA	[^<>"&]+	nop
RIBTLA	\{HTML-Escape}\&[a-zA-Z]+;	nop
#
#  Commands
#
RIBTLA	\{HTML-Command}<it\>:<em\>:<address\>:<cite\>:<var\>	push I, push D
RIBTLA	\{HTML-Command}<IT\>:<EM\>:<ADDRESS\>:<CITE\>:<VAR\>	push I, push D
RIBTLA	\{HTML-Command}<b\>:<dt\>:<h[4-9]\>	push B, push D
RIBTLA	\{HTML-Command}<B\>:<DT\>:<H[4-9]\>	push B, push D
RIBTLA	\{HTML-Command}<tt\>:<pre\>:<code\>:<key\>:<kbd\>:<samp\>	push T, push D
RIBTLA	\{HTML-Command}<TT\>:<PRE\>:<CODE\>:<KEY\>:<KBD\>:<SAMP\>	push T, push D
RIBTLA	\{HTML-Command}<large\>:<h[1-3]\>:<title\>	push L, push D
RIBTLA	\{HTML-Command}<LARGE\>:<H[1-3]\>:<TITLE\>	push L, push D
RIBTLA	\{HTML-Command}<a[ \t]+href\>	push A, push D
RIBTLA	\{HTML-Command}<A[ \T]+HREF\>	push A, push D
RIBTLA	\{HTML-Command}</it\>:</em\>:</address\>:</cite\>:</var\>:</b\>:<dd\>:</h[1-9]\>:</tt\>:</pre\>:</code\>:</key:</kbd\>:</samp\>:</large\>:</title\>:</a\>	goto D
RIBTLA	\{HTML-Command}</IT\>:</EM\>:</ADDRESS\>:</CITE\>:</VAR\>:</B\>:<DD\>:</H[1-9]\>:</TT\>:</PRE\>:</CODE\>:</KEY:</KBD\>:</SAMP\>:</LARGE\>:</TITLE\>:</A\>	goto D
RIBTLA	\{HTML-Command}<	push D
#
#  Command trailers
#
D	--	goto C
D	>	pop
D	[a-zA-Z]+	nop
D	"\{HTML-String}[^"]*\{HTML-Command}"	nop
#
#  Comments
#
C	\{HTML-Command}--	goto D
