#
#  Bounded stack language for search patterns (search panel)
#
BSL type finite-state intra-line

typefaces
r----	Panel-Plain
rb-r-	Panel-Wildcard
r--g-	Panel-CharacterRange
r--b-	Panel-Set

state set
E	Panel-Plain
O	Panel-CharacterRange
R	Panel-Plain
M	Panel-Plain

rules
#
#  E = Expression body
#
E	\{Panel-Set}\:		nop
E	\{Panel-Wildcard}\\[()<>nt]		nop
E	\{Panel-Wildcard}\\\{Panel-Plain}?		nop
E	\{Panel-Wildcard}\?		nop
E	\{Panel-Wildcard}\*		nop
E	\{Panel-Wildcard}\&[0-9]\{Panel-CharacterRange}[/]!		push R, push R
E	\{Panel-Wildcard}\&[0-9]		nop
E	\{Panel-Wildcard}\^		nop
E	\{Panel-Wildcard}\$		nop
E	\{Panel-CharacterRange}[\[]!\^		goto O, push R
E	\{Panel-CharacterRange}[\[]!		goto O, push R
#
#  R = range, first character
#  M = range, expect to see a minus
#
RM	\{Panel-CharacterRange}&0/[/]		pop
RM	\{Panel-Wildcard}\\[nt]		goto M
RM	\{Panel-Wildcard}\\\{Panel-Plain}?		goto M
R	?		goto M
M	\{Panel-CharacterRange}-\{Panel-Wildcard}\\[nt]		goto R
M	\{Panel-CharacterRange}-\{Panel-Wildcard}\\\{Panel-Plain}?	goto R
M	\{Panel-CharacterRange}-\{Panel-Plain}?		goto R
#
#  O = expect operator after a square bracket range
#
O	[1*+?!]		goto E
O			goto E
